POJ2528——Mayor's posters

Mayor‘s posters

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 44910   Accepted: 13059

Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral
wall for placing the posters and introduce the following rules:

  • Every candidate can place exactly one poster on the wall.
  • All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
  • The wall is divided into segments and the width of each segment is one byte.
  • Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates
started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.

Your task is to find the number of visible posters when all the posters are placed given the information about posters‘ size, their place and order of placement on the electoral wall.

Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they
were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li
<= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,... , ri.

Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10

Sample Output

4

Source

Alberta Collegiate Programming Contest 2003.10.18

很好的一道题,首先要离散化,之前用map超时,改成二分就行了,看来以后得用二分

线段树维护一段区间的颜色

#include <map>
#include <set>
#include <list>
#include <queue>
#include <stack>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

const int N = 20110;

int xis[N], ans, cnt, ret;
bool flag[N];
struct node
{
	int l, r;
	int col;
}tree[N << 2];

struct node2
{
	int l, r;
}post[N];

int BinSearh(int target)
{
	int l = 1, mid, r = ret;
	while (l <= r)
	{
		mid = (l + r) >> 1;
		if (xis[mid] > target)
		{
			r = mid - 1;
		}
		else if (xis[mid] < target)
		{
			l = mid + 1;
		}
		else
		{
			break;
		}
	}
	return mid;
}

void build(int p, int l, int r)
{
	tree[p].l = l;
	tree[p].r = r;
	tree[p].col = 0;
	if (l == r)
	{
		return;
	}
	int mid = (l + r) >> 1;
	build(p << 1, l, mid);
	build(p << 1 | 1, mid + 1, r);
}

void update(int p, int l, int r, int col)
{
	if (l <= tree[p].l && tree[p].r <= r)
	{
		tree[p].col = col;
		return;
	}
	if (tree[p].col)
	{
		tree[p << 1].col = tree[p].col;
		tree[p << 1 | 1].col = tree[p].col;
		tree[p].col = 0;
	}
	int mid = (tree[p].l + tree[p].r) >> 1;
	if (l > mid)
	{
		update(p << 1 | 1, l, r, col);
	}
	else if (r <= mid)
	{
		update(p << 1, l, r, col);
	}
	else
	{
		update(p << 1, l, mid, col);
		update(p << 1 | 1, mid + 1, r, col);
	}
}

void query(int p)
{
	if (tree[p].col)
	{
		if (!flag[tree[p].col])
		{
			ans++;
			flag[tree[p].col] = 1;
		}
		return;
	}
	query(p << 1);
	query(p << 1 | 1);
}

int main()
{
	int t, n;
	scanf("%d", &t);
	while (t--)
	{
		scanf("%d", &n);
		memset (flag, 0, sizeof(flag));
		map <int, int> new_x;
		new_x.clear();
		cnt = ans = 0;
		for (int i = 1; i <= n; ++i)
		{
			scanf("%d%d", &post[i].l, &post[i].r);
			xis[++cnt] = post[i].l;
			xis[++cnt] = post[i].r;
		}
		sort (xis + 1, xis + cnt + 1);
		ret = unique(xis + 1, xis + cnt + 1) - xis - 1;
		build(1, 1, ret);
		for (int i = 1; i <= n; ++i)
		{
			int l = BinSearh(post[i].l);
			int r = BinSearh(post[i].r);
			update(1, l, r, i);
		}
		query(1);
		printf("%d\n", ans);
	}
	return 0;
}

POJ2528——Mayor's posters

时间: 2024-10-17 08:00:56

POJ2528——Mayor's posters的相关文章

【线段树+离散化】POJ2528 Mayor&#39;s posters

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 64939   Accepted: 18770 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

poj2528 Mayor&#39;s posters(线段树,离散化)

离散化的思想: 对于这样的数据 (3,10000), (9,1000000), (5,100000), (1,1000), (7,1000000) 我们可以将其处理为 (2,7), (5,9), (3,8), (1,6), (4,9) 我们再对离散化之后的数据进行处理就行了. 题目意思: n(n<=10000)个人依次贴海报,给出每张海报所贴的范围li,ri(1<=li<=ri<=10000000). 求出最后还能看见多少张海报. 参考代码: #include <iostre

POJ2528 Mayor&#39;s posters(线段树染色问题+离散化)

题目大意:有t组数据,每组数据给你n张海报(1<=n<=10000),下面n组数据分别给出每张海报的左右范围(1 <= l <= r <= 10000000),下一张海报会覆盖前一张海报,求最后可见(包括完全和不完全可见)的海报有几张. 例如: 1 5 1 4 2 6 8 10 3 4 7 10 如上图所示,答案为4. 解题思路:其实这是一道区间染色问题,但是由于查找区间太大,显然直接建树会导致MLE,所以这里通过使用对区间的离散化来缩小查找范围.参考了一些大牛博客,简单说一

POJ2528 Mayor&#39;s posters 【线段树】+【成段更新】+【离散化】

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 39795   Accepted: 11552 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

poj-----(2528)Mayor&#39;s posters(线段树区间更新及区间统计+离散化)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 43507   Accepted: 12693 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

poj2528 Mayor&#39;s posters 2011-12-20

Mayor's posters Time Limit: 1000MSMemory Limit: 65536K Total Submissions: 23344Accepted: 6747 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at

poj2528 Mayor&#39;s posters(线段树+离散化)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 42808   Accepted: 12481 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

POJ2528 Mayor&#39;s posters(线段树成段替换,区间查询,离散化简单hash)

题意:在墙上贴海报,海报可以互相覆盖,问最后可以看见几张海报 思路:这题数据范围很大,直接搞超时+超内存,需要离散化: 离散化简单的来说就是只取我们需要的值来 用,比如说区间[1000,2000],[1990,2012] 我们用不到[-∞,999][1001,1989][1991,1999][2001,2011][2013,+∞]这些值,所以我只需要 1000,1990,2000,2012就够了,将其分别映射到0,1,2,3,在于复杂度就大大的降下来了 所以离散化要保存所有需要用到的值,排序后,

poj2528 Mayor&#39;s posters (线段树+离散化)

恩,这区间范围挺大的,需要离散化.如果TLE,还需要优化一下常数. AC代码 #include <stdio.h> #include <string.h> #include <map> #include <set> #include <algorithm> using namespace std; const int maxn = 40000+5; typedef pair<int, int> Pii; Pii a[10000 + 5